require "text_common/version"
require 'digest/sha1'
require 'ostruct'
require 'json'

module TextCommon
  class Error < StandardError; end
  # Your code goes here...
  
  # https://stackoverflow.com/questions/29320369/coping-with-string-contains-null-byte-sent-from-users
  def self.clean_null_bytes(string)
    return string.delete("\u0000")
  end
  
  def self.clean_bytes(string)
    string.gsub("\u0000", '').gsub("\xE2",'').gsub("\xE3",'')    
  end
  
  #TODO
  def self.clean_utf16(string)
  end
  
  def self.regex_to_string(regex)
    text = regex.to_s.split(':').last.sub(/\)$/,'').upcase
    return text.gsub(/\?/,'').gsub('.+','_').gsub('[ \-]','_').gsub(' ','_').strip
  end
  
  #https://www.justinweiss.com/articles/3-steps-to-fix-encoding-problems-in-ruby/
  def self.convert_utf16_to_utf8(string)
    return string.encode('UTF-8', invalid: :replace, undef: :replace)
  end
  

  
  # TESTED
  def self.sha(text)
    #return "" if text.nil?
    return Digest::SHA1.hexdigest(text.to_s)
  end
  
  # tested
  # todo strip html and then count words
  # todo nick readability python sublime
  def self.count_words(text)
    parts = text.split(" ")
    return parts.size
  end
  
  def self.present_key(str)
    parts = str.split("_")
    str = parts.map(&:capitalize).join(' ')
    return str
  end
  
  def self.convert_k_to_number(text)
    if text =~ /k/i
      #2.9k
      parts = text.split(/k/i)
      return (parts[0].to_f*1000).round(0)
    elsif text =~ /m/i
      #2.9k
      parts = text.split(/m/i)
      return (parts[0].to_f*1000000).round(0)
    end
    return text
  end
  
  def self.strip_breaks(text)
    return text.gsub(/\n/,'').gsub(/\r/,'')
  end
  
  def self.sha_it(text)
    text = text.to_json if text.is_a?(Hash) || text.is_a?(Array)
    return Digest::SHA1.hexdigest(text.to_s)
  end
  
  def self.suggest_hash_tags(text)
  end
  

  
  
  # return a true or false when a post is "NOTABLE" i.e. actually significant
  # look at gauging the economic amount / ECONOMIC VALUE of work that went into it: 
  #  * a lot of links are notable
  #  * a lof of words are notable
  #  * rich amounts of tag elements are notable
  #. * a short bit of content likely isn't
  # distinguish between a reblogged thing or a link blog item
  def self.is_notable?(text)
  end
  

  
  def self.create_hash_tags(text)
  end
  
  def self.create_category(text)
  end
end
